package echo.actions;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringWriter;

import org.apache.jetspeed.modules.actions.portlets.JspPortletAction;
import org.apache.jetspeed.portal.Portlet;
import org.apache.jetspeed.services.rundata.JetspeedRunData;
import org.apache.jetspeed.services.statemanager.SessionState;

import org.apache.turbine.util.upload.FileItem;
import org.apache.turbine.util.RunData;

import org.apache.velocity.context.Context;

public class TextUploadAction extends JspPortletAction  {

  public void buildNormalContext( Portlet portlet, RunData runData )
              throws Exception  {
    SessionState sessionState = ((JetspeedRunData)runData).getPageSessionState();
    String text = (String)sessionState.getAttribute( "text" );
    if ( text == null )
            text = portlet.getPortletConfig().getInitParameter( "text" );
    runData.getSession().setAttribute( "text", text );

  }

  public void doUpdate( RunData runData, Context context ) throws Exception  {

    FileItem file = runData.getParameters().getFileItem("file");

    if ( file == null )  return;

    BufferedReader in = new BufferedReader(
        new InputStreamReader( file.getInputStream(), "JISAutoDetect" ) );
    StringWriter out = new StringWriter();
    String line;
    while( ( line = in.readLine() ) != null )  {
      for( int pos = 0; pos < line.length(); pos++ )  {
        char ch = line.charAt( pos );
        switch( ch )  {
          case '&' :
            out.write( "&amp;" );
            break;
          case '<' :
            out.write( "&lt;" );
            break;
          case '>' :
            out.write( "&gt;" );
            break;
          case '\"' :
            out.write( "&quot;" );
            break;
          case ' ' :
            out.write( "&nbsp;" );
          default :
            out.write( ch );
        }
      }
      out.write( "<br>" );
    }
    SessionState sessionState =
                      ((JetspeedRunData)runData).getPageSessionState();
    sessionState.setAttribute( "text", out.toString() );
    out.close();
  }

}
